#!/usr/bin/env python
# -*- coding: utf-8 -*-
# import django
# import os
#
# os.environ['DJANGO_SETTINGS_MODULE'] = 'starpro.settings'
# django.setup()
import json
import sys
import httplib

import xmltodict
from bs4 import BeautifulSoup

import requests
# from suds.client import Client
# sys.setrecursionlimit(1000000)
import zeep
from zeep import Client, Settings, Transport
from zeep.helpers import serialize_object
from zeep.cache import InMemoryCache


def make_product_xml(**kwargs):
    product_dict = {
        "ProductPackage": {
            "@Name": "test_Greg_DemandeDecreaProduit_API_Variant_SOJ144731",
            "@xmlns": "clr-namespace:Cdiscount.Service.ProductIntegration.Pivot;assembly=Cdiscount.Service."
                      "ProductIntegration",
            "@xmlns:x": "http://schemas.microsoft.com/winfx/2006/xaml",
        }
    }
    Product_collection = {

    }
    product_dict["ProductPackage.Products"]


if __name__ == "__main__":
    # env = "www.cdiscount.com"
    # accept = "gzip,deflate"
    # content_type = "text/xml;charset=UTF-8"

    soap_message = """<s:Envelope xmlns:s="http://schemas.xmlsoap.org/soap/envelope/">
            <s:Body>
                <GetModelList xmlns="http://www.cdiscount.com">
                    <headerMessage xmlns:a="http://schemas.datacontract.org/2004/07/Cdiscount.Framework.Core.Communication.Messages" xmlns:i="http://www.w3.org/2001/XMLSchema-instance">
                        <a:Context>
                            <a:CatalogID>1</a:CatalogID>
                            <a:CustomerPoolID>1</a:CustomerPoolID>
                            <a:SiteID>100</a:SiteID>
                        </a:Context>
                        <a:Localization>
                            <a:Country>Fr</a:Country>
                            <a:Currency>Eur</a:Currency>
                            <a:DecimalPosition>2</a:DecimalPosition>
                            <a:Language>Fr</a:Language>
                        </a:Localization>
                        <a:Security>
                            <a:DomainRightsList i:nil="true" />
                            <a:IssuerID i:nil="true" />
                            <a:SessionID i:nil="true" />
                            <a:SubjectLocality i:nil="true" />
                            <a:TokenId>${#Project#token}</a:TokenId>
                            <a:UserName i:nil="true" />
                        </a:Security>
                        <a:Version>1.0</a:Version>
                    </headerMessage>
                    <modelFilter xmlns:i="http://www.w3.org/2001/XMLSchema-instance">
                        <CategoryCodeList xmlns:a="http://schemas.microsoft.com/2003/10/Serialization/Arrays">
                            <a:string>06010201</a:string>
                        </CategoryCodeList>
                    </modelFilter>
                </GetModelList>
            </s:Body>
        </s:Envelope>
    """
    settings = Settings(strict=False, xml_huge_tree=True)
    transport = Transport(cache=InMemoryCache())
    client = Client("https://wsvc.cdiscount.com/MarketplaceAPIService.svc?wsdl")
    # client = Client("https://my-wsdl/wsdl", settings=settings)
    print "--------------------------------------------------------"
    # print json.dumps(serialize_object(client))
    with client.settings(raw_response=True):
        # response = client.service.GetOfferList()
        # print response.status_code
        # print response.content
        # print response.json()
        # _soapheaders=headers,
        # Bondz, Bondz-api, Xingsha5216& 5e77fafa5eef428f88d2e6c99f32bb40
        token = "5e77fafa5eef428f88d2e6c99f32bb40"
        data = {
            "headerMessage": {
                "Context": {
                    "CatalogID":  "1",
                    "CustomerPoolID": "1",
                    "SiteID": "100"
                },
                "Localization": {
                    "Country": "Fr",
                    "Currency": "Eur",
                    "DecimalPosition": "2",
                    "Language": "Fr"
                },
                "Security": {
                    "TokenId": token
                },
            },
            "productPackageRequest": {
                "ZipFileFullPath": "http://54.196.103.47:8999/upload/products.zip"
            },
            # "modelFilter": {
            #     "CategoryCodeList": {
            #         "string": "06010201"
            #     }
            # }
        }
        # d827cd8729d94d69a4d15c0fbbe9d7e4
        # 7cb6fb02a83c45b38f8511bf348d1c36
        # res = client.service.GetModelList(**data)
        res = client.service.SubmitProductPackage(**data)
        print res.status_code
        print res.content

    product_message = '''
    <Product   BrandName="Deeluxe" SellerProductFamily ="SOJ50874" SellerProductColorName = "Bleu Délavé" Size ="36/34"   Description="Nudie Average Joe organic vacation worn Jeans Droite Homme 100% Organic"  LongLabel="Jeans Deeluxe Tanner Snow Bleu" Model="SOUMISSION CREATION PRODUITS_MK"  ProductKind="Variant" CategoryCode="0R050A01" SellerProductId="120905784"  ShortLabel="Jeans Deeluxe Tanner Snow Bleu" EncodedMarketingDescription="RGVzY3JpcHRpb24gcXVpIGNvbnRpZW50IGR1IDxzdHJvbmc+SFRNTDwvc3Ryb25nPg==">
        <Product.EanList>
          <ProductEan Ean="3606918243774"/>
        </Product.EanList>
        <Product.ModelProperties>
          <x:String x:Key="Genre">Homme - Garçon</x:String>
		  <x:String x:Key="Type de public">Adulte</x:String>
        </Product.ModelProperties>
        <Product.Pictures>
          <ProductImage Uri="https://starmerx.oss-cn-shanghai.aliyuncs.com/PEL_02KC_302642.jpg"/>
		  <ProductImage Uri="https://starmerx.oss-cn-shanghai.aliyuncs.com/PEL_02KC_302643.jpg"/>
		  <ProductImage Uri="https://starmerx.oss-cn-shanghai.aliyuncs.com/PEL_02KC_302644.jpg"/>
		  <ProductImage Uri="https://starmerx.oss-cn-shanghai.aliyuncs.com/PEL_02KC_302645.jpg"/>
        </Product.Pictures>
      </Product>
    '''
    # with open("test.txt", "a+") as f:
    #     for i in range(9998):
    #         f.write(product_message + "\n")

    # result_dict = xmltodict.parse(product_message)
    # print result_dict
    # print json.dumps(result_dict)
    #
    # print xmltodict.unparse(result_dict)
